using System;
using System.Diagnostics;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;

namespace BindingArrayList
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl dataGridViewTranslation;
        private Button button1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;


	    public BindingList<TextPair> Translation;
	    public BindingList<TextPair> TranslationDetails;

	    private void CreateLists()
	    {
	        Translation = new BindingList<TextPair>();
	        TranslationDetails = new BindingList<TextPair>();
            Translation.Add(new TextPair("Text 1"));
            Translation.Add(new TextPair("Text 2"));
            Translation.Add(new TextPair("Text"));
            Translation.Add(new TextPair("Text 3"));
            Translation.Add(new TextPair("Text 4"));

            TranslationDetails.Add(new TextPair("Text"));
            TranslationDetails.Add(new TextPair("Text"));
            TranslationDetails.Add(new TextPair("Text"));
            TranslationDetails.Add(new TextPair("Text"));
        }


		public Form1()
		{
	        CreateLists();

		    GridEngineFactory.Factory = new GroupingEngineFactory();
		    //
			// Required for Windows Form Designer support
			//
			InitializeComponent();

		    FillTranslationGrid();
		}

        ///<summary>
        /// Fills the translation list with data.
        ///</summary>
        public void FillTranslationGrid()
        {
            dataGridViewTranslation.SuspendLayout();

            BindingList<TextPair> parentList = Translation;
            BindingList<TextPair> childList = TranslationDetails;

            // Manually specify relations in grouping engine between independent ILists.
            GridRelationDescriptor parentToChildRelationDescriptor = new GridRelationDescriptor();
            parentToChildRelationDescriptor.ChildTableName = "TranslationDetailsList";
            parentToChildRelationDescriptor.RelationKind = RelationKind.RelatedMasterDetails;
            parentToChildRelationDescriptor.RelationKeys.Add("SourceKey", "SourceKey");

            // Add relation to ParentTable 
            dataGridViewTranslation.TableDescriptor.Relations.Add(parentToChildRelationDescriptor);

            // Register any DataTable/IList with SourceListSet, so that RelationDescriptor can resolve the name
            dataGridViewTranslation.Engine.SourceListSet.Add("TranslationList", parentList);
            dataGridViewTranslation.Engine.SourceListSet.Add("TranslationDetailsList", childList);

            dataGridViewTranslation.DataSource = parentList;

            GridTableModel tbl = dataGridViewTranslation.GetTableModel("TranslationDetailsList");
            tbl.QueryRowHeight += tbl_QueryRowHeight;

            UpdateGridView();
        }

        private void UpdateGridView()
        {
            //Set the parent/master properties
            dataGridViewTranslation.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
            dataGridViewTranslation.TopLevelGroupOptions.ShowCaption = false;
            dataGridViewTranslation.Appearance.AnyCell.TextColor = Color.MidnightBlue;

            // Remove the SourceKey and the IsTheMaster column and make readonly the Source 
            dataGridViewTranslation.TableDescriptor.VisibleColumns.Remove("SourceKey");
            dataGridViewTranslation.TableDescriptor.VisibleColumns.Remove("IsTheMaster");
            dataGridViewTranslation.TableDescriptor.Columns["Source"].ReadOnly = true;
            dataGridViewTranslation.TableDescriptor.Columns["ControlPath"].ReadOnly = true;
            

            //set some child properties  
            RelationDescriptor parentToChildRelationDescriptor1 = dataGridViewTranslation.TableDescriptor.Relations["TranslationDetailsList"];
            GridTableDescriptor childTableDescriptor = (GridTableDescriptor)parentToChildRelationDescriptor1.ChildTableDescriptor;
            childTableDescriptor.AllowNew = false;
            childTableDescriptor.Columns["Source"].ReadOnly = true;
            childTableDescriptor.Columns["ControlPath"].ReadOnly = true;
            //Hide the last column of the child.
            childTableDescriptor.VisibleColumns.Remove("IsTheMaster");

            //HERE IS THE PROBLEM!!!!!!!
            GridTableModel tbl = dataGridViewTranslation.GetTableModel("TranslationDetailsList");
            tbl.QueryRowHeight += tbl_QueryRowHeight;

        }
        void tbl_QueryRowHeight(object sender, GridRowColSizeEventArgs e)
        {
            // Hide the title and header
            if ((e.Index == 0) || (e.Index == 1))
            {
                e.Size = 0;
                e.Handled = true;
            }
        }


	    /// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.dataGridViewTranslation = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            this.button1 = new System.Windows.Forms.Button();
            ((System.ComponentModel.ISupportInitialize)(this.dataGridViewTranslation)).BeginInit();
            this.SuspendLayout();
            // 
            // dataGridViewTranslation
            // 
            this.dataGridViewTranslation.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                        | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.dataGridViewTranslation.BackColor = System.Drawing.SystemColors.Window;
            this.dataGridViewTranslation.Location = new System.Drawing.Point(0, 24);
            this.dataGridViewTranslation.Name = "dataGridViewTranslation";
            this.dataGridViewTranslation.Size = new System.Drawing.Size(575, 271);
            this.dataGridViewTranslation.TabIndex = 0;
            this.dataGridViewTranslation.Text = "gridGroupingControl1";
            this.dataGridViewTranslation.VersionInfo = "4.200.0.60";
            this.dataGridViewTranslation.QueryCellStyleInfo += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventHandler(this.gridGroupingControl1_QueryCellStyleInfo);
            this.dataGridViewTranslation.TableControlMoveCurrentCellDirection += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlMoveCurrentCellDirectionEventHandler(this.dataGridViewTranslation_TableControlMoveCurrentCellDirection);
            // 
            // button1
            // 
            this.button1.Location = new System.Drawing.Point(423, 315);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(106, 23);
            this.button1.TabIndex = 1;
            this.button1.Text = "Change";
            this.button1.UseVisualStyleBackColor = true;
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(575, 375);
            this.Controls.Add(this.button1);
            this.Controls.Add(this.dataGridViewTranslation);
            this.Name = "Form1";
            this.Text = "BindingArrayList...";
            ((System.ComponentModel.ISupportInitialize)(this.dataGridViewTranslation)).EndInit();
            this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}


        private void button1_Click(object sender, EventArgs e)
        {
            FillTranslationGrid();
        }

        private void gridGroupingControl1_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
        {
            // Prevent the +/- Icon for an empty row
            if (e.TableCellIdentity.TableCellType == GridTableCellType.RecordPlusMinusCell)
            {
                Record r = e.TableCellIdentity.DisplayElement.ParentRecord;
                if (r != null && r.NestedTables.Count > 0
                    && r.NestedTables[0].ChildTable.GetFilteredRecordCount() == 0)
                {
                    Debug.WriteLine(r.NestedTables.Count);

                    e.Style.CellType = "Static";
                    e.Style.Borders.Bottom = new GridBorder(this.dataGridViewTranslation.TableModel.Options.DefaultGridBorderStyle, SystemColors.GrayText);
                }
            }
        }

        private void dataGridViewTranslation_TableControlMoveCurrentCellDirection(object sender, GridTableControlMoveCurrentCellDirectionEventArgs e)
        {
            GridTableCellStyleInfo style = e.TableControl.Model[e.Inner.RowIndex, e.Inner.ColIndex];
            int lastPos = style.TableCellIdentity.Table.TableDescriptor.VisibleColumns.Count - 1;

            string lastName = style.TableCellIdentity.Table.TableDescriptor.VisibleColumns[lastPos].Name;
            if (style.TableCellIdentity.Column.MappingName == lastName && e.Inner.Direction == GridDirectionType.Right)
            {
                Element el = style.TableCellIdentity.DisplayElement;

                if (el != null)
                {
                    GridRecord rec = el.ParentRecord as GridRecord;
                    int index = style.TableCellIdentity.Table.FilteredRecords.IndexOf(rec);
                    if (index < style.TableCellIdentity.Table.FilteredRecords.Count - 1)
                    {
                        rec = style.TableCellIdentity.Table.FilteredRecords[index + 1] as GridRecord;
                        rec.SetCurrent(style.TableCellIdentity.Table.TableDescriptor.VisibleColumns[0].Name);
                        e.Inner.Handled = true;
                        e.Inner.Result = true;
                    }
                }
            }
        }
    
    
    }


}

