﻿#region Copyright © Suetron electronic GmbH, Germany
//------------------------------------------------------------------------------
// Filename  : GroupingChildTable.cs
//------------------------------------------------------------------------------
// Copyright © Suetron electronic GmbH, Germany 2006
// 
// Sütron electronic GmbH
// Kurze Straße 29
// 70794 Filderstadt
// Germany
//------------------------------------------------------------------------------
// Author  : EAchim
// Changes : 
//------------------------------------------------------------------------------
#endregion

#region namespace usage / imports / aliases

using System;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid.Grouping;

#endregion //namespace usage / imports / aliases

namespace BindingArrayList
{
    /// <summary>
    /// GroupingEngineFactory provides a trimmed down GridGroup
    /// which eliminates overhead of not needed preview rows, header and footer cells.
    /// </summary>
    public class GroupingEngineFactory : GridEngineFactoryBase
    {
        // Add this line in your forms ctor:
        // GroupingEngineFactory provides a modified GridChildTable that adds an extra section
        // GridEngineFactory.Factory = new GroupingEngineFactory();

        public override GridEngine CreateEngine()
        {
            return new GroupingEngine();
        }
    }

    public class GroupingEngine : GridEngine
    {
        public override ChildTable CreateChildTable(Element parent)
        {
            return new GroupingChildTable(parent);
        }
    }


    /// <summary>
    /// Derived GridChildTable that gets hidden when it has no records to show.
    /// </summary>
    public class GroupingChildTable : GridChildTable
    {
        public GroupingChildTable(Element parent)
            : base(parent)
        {
        }

        /// <override/>
        public override int GetVisibleCount()
        {
            if (this.Details == null || this.Records.Count == 0)
                return 0;

            return base.GetVisibleCount();
        }

        /// <override/>
        public override double GetYAmountCount()
        {
            if (this.Details == null || this.Records.Count == 0)
                return 0;

            return base.GetYAmountCount();
        }

        /// <override/>
        public override double GetVisibleCustomCount()
        {
            if (this.Details == null || this.Records.Count == 0)
                return 0;

            return base.GetVisibleCustomCount();
        }
    }
}
