﻿using System;
using System.Collections.Generic;
using System.Text;

namespace BindingArrayList
{
    public class TextPair
    {

        #region non-static members ======================================================


        #region properties/indexer (private, protected, public)
        /// <summary>
        /// Remark if this pair is used as the master
        /// </summary>
        private bool _isTheMaster;

        private string _source;
        private string _destination;

        /// <summary>
        /// Used as dummy key to establish the relation master/detail.
        /// </summary>
        public string SourceKey
        {
            get { return Source; }
            set { Source = value; }
        }

        /// <summary>
        /// The value of the property in the source culture.
        /// </summary>
        public string Source
        {
            get { return _source; }
            set { _source = value; }
        }

        /// <summary>
        /// The value of the property in the destination culture.
        /// </summary>
        public string Destination
        {
            get { return _destination; }
            set { _destination = value; }
        }

        /// <summary>
        /// The Path of the control (empty if the translation is a master one)
        /// </summary>
        public string ControlPath
        {
            get
            {
                return "\\Bla\\asa";
            }
        }

        /// <summary>
        /// Remark if this pair is used as the master
        /// </summary>
        public bool IsTheMaster
        {
            get { return _isTheMaster; }
            set { _isTheMaster = value; }
        }

        #endregion //properties/indexer (private, protected, public)

        #region functions (private, protected, public)

        public TextPair(string source)
        {
            _source = source;
        }

        #endregion //functions (private, protected, public)

        #endregion //non-static members =================================================
    }
}
